
function Top_ritorno_s=Clean_TOP_Ev(Tag_Ev,Top_Ev)


%% Estrapolo i basic event 
t=join(Tag_Ev,'@');
t=strrep(t,'+','@');
t=strrep(t,'*','@');
t=strrep(t,' ','@');
t=strsplit(string(t),'@');
t=cellstr(t');
Tag_Ev=t;

% Rimuovo le tag ridondanti
% ordina anche le tag degli eventi dalla A alla Z
Tag_Ev=unique(Tag_Ev);


%% Tag eventi fantoccio
for i=1:length(Tag_Ev)        
         TagParte1='x';
         TagParte2=string(i);
         Tagparte3='x';
         Ev(i)=strcat(TagParte1,TagParte2,Tagparte3);       
end
Ev=cellstr(Ev');
  
    %% Iserisco le Tag degli eventi come variabili simboliche nel workspace a partire da un vettore cella di stringhe 
    % passo da stringa da simboli per utilizzare l'equazione expand e
    % fattorizzare l'espressione del top
for jj=1:length(Ev) 
       apic='''';          
%{
    Quello che avrei dovuto inserire a mano come :  syms TOP A B C D
    lo faccio fare tramite un ciclo "for" ad eval
    --> eval= qualunque comando compreso in forma di stringa viene eseguito come un comando matlab 
    --> Carica nel workspace le Tag degli eventi come variabili simboliche
%}  
     eval([Ev{jj} '=sym(' apic Ev{jj} apic  ')']);
end


%% Fattorizzo Top
Top_string=string(Top_Ev);
Top_string=str2sym(Top_string);      
Top_string=[expand(Top_string)];
%% Riporto a stringa
Top_string=string(Top_string);
% scompatto
Top_string = insertAfter(Top_string,"*"," ");
Top_string = insertBefore(Top_string,"*"," ");
Top_string = insertBefore(Top_string,"^"," ");
Top_string = insertAfter(Top_string,"^"," ");
Top_string=strsplit(Top_string,' ');

%% Cambio Tag eventi
% Uso "Tag fantoccio" per risolvere i problemi legati alla aleatoriet delle Tag degli eventi immessi dallo user 
 for k=1:length(Ev)  % tag fantoccio    
     for j=1:length(Top_string)         
         if strcmp(Tag_Ev{k},Top_string(j))            
            Top_string(j)= replace(Top_string(j),Tag_Ev{k},Ev(k));
         end
     end
 end
 % Ricompatto
Top_string=join(Top_string,' ');
Top_string=strrep(Top_string,' ','');
Top_raw=string(Top_string);

%% PULIZIA Top event 
%{
Per calcolare le ripetizioni (per avere una stima delle potenze e delle moltiplicazioni degli eventi fattorizzati)
ho bisogno di un cell array di stringhe unite tra loro, quindi trasformo...
Trovo il numero massimo di ripetizioni di un evento in modo da valutarne il valore massimo che pu assumere la potenza di un evento fattorizzato
%}
for ll=1:length(Ev)   
    ripetizioni_evento(ll)= count(Top_raw,Ev(ll));    
end
%{
un evento al quadrato puo ripetersi anche una sola volta quindi non riesco
ad eliminare ad esempio il "^2" se si ripete una sola volta, allora aggiungo un surplus di ripetizioni per
ovviare a tale problema, il costo computazionale aumenta; 
ovviamente  molto difficile il caso in cui si abbiano eventi che numericamente sono considerati al quadrato...
o al cubo e che per le regole di probabilit poi alla fine sono conisederati come un unico evento! 
%}    

% Coefficiente correttivo 

coeff_corr=length(Tag_Ev);
max_rip=max(ripetizioni_evento)+coeff_corr;

%% Pulizia 
% Pulisco le potenze " ^n" 
% TOP_split_raw=strrep(TOP_split_raw,'^','');
for lll=1:max_rip
    elev='^';
    num=string(lll);
    elev_comb=strcat(elev,num);
    Top_raw=strrep(Top_raw,elev_comb,'');
end

% Pulisco i numeri moltiplicati " n* " 
for lll=1:max_rip
    asterisco='*';
    num=string(lll);
    num_comb=strcat(num,asterisco);        
    Top_raw=strrep(Top_raw,num_comb,'');    
end

%% TOP event <PULITO>
TOP_clean=Top_raw;
% scompatto top event
TOP_clean = insertAfter(TOP_clean,"*"," ");
TOP_clean = insertBefore(TOP_clean,"*"," ");

TOP_clean = insertAfter(TOP_clean,"+"," ");
TOP_clean = insertBefore(TOP_clean,"+"," ");

TOP_clean = insertBefore(TOP_clean,"^"," ");
TOP_clean = insertAfter(TOP_clean,"^"," ");
% scompatto tutto
TOP_clean=strsplit(TOP_clean,' ');

%% Restituisco le Tag originali degli eventi

 for k=1:length(Ev)  % tag fantoccio    
     for j=1:length(TOP_clean)
         
         if strcmp(Ev{k},TOP_clean(j))
            
            TOP_clean(j)= replace(TOP_clean(j),Ev(k),Tag_Ev{k});

         end
     end
 end
TOP_clean=join(TOP_clean,' ');
TOP_clean=strrep(TOP_clean,' ','');
TOP_clean = insertAfter(TOP_clean,"+"," ");
TOP_clean = insertBefore(TOP_clean,"+"," ");

Top_ritorno_s=TOP_clean;    % Top event di ritorno pulito 

end % End function 