
%%  Note
% BC=block connection type
% f= handle basic event 
% Ev= vettore cella che contiene le info dei "Basic Ev", identificativo porta di destinazione
% BC= handle dei blocchi connessi ai basic event, identificativo blocco di destinazione
% gate= porte collegate 

%% Funzione che prende le info dai Basic Event del modello (es. FTA) in uso
%% Inseriti anche i CCF

function [f,Ev,BC,gate]=Get_block_BasicEv_CCF(modello)

% Prendo handle Basic event 
f=find_system(modello,'MaskType','Basic_Event');
% Trova i nomi Mask Type di tutti i blocchi che si chiamano Basic Event...
... e li mette in un array di celle; 
f=cell2mat(get_param(f,'Handle')); 
% Prendo Handle CCF event
f_ccf=find_system(modello,'MaskType','CCF_Event');    
f_ccf=cell2mat(get_param(f_ccf,'Handle'));

% Unisco in un unico array double le handle
if isempty(f_ccf)
    ff=f; % solo basic
else
ff=[f ;f_ccf];  % basic+ccf
end


Ev=cell(1,1); % Inizializzo il vettore che conterr la tag degli eventi
for h=1:length(ff)
    % Handle del Basic Event che viene ciclato
    g=ff(h);
    % "Ev", deve essere un cell perch sono stringhe che possono...
    ...avere lunghezze differenti e non posso metterlo in una matrice, 
     ...perch tutti gli elementi devono avere la stessa lunghezza, 
     ...ma nel nostro caso non sar cosi perch abbiamo a che fare con un "nome di evento";
    Ev{h,1}=get_param(g,'tag_ev');       %   | Tag Evento |
    Ev{h,2}=get_param(g,'lam_mttf');     %   |  lambda(t) |
    Ev{h,3}=get_param(g,'UnAv');         %   |    Q(t)    |
    Ev{h,4}=get_param(g,'UnRe');         %   |    F(t)    |
    Ev{h,5}=get_param(g,'f_density');    %   |    w(t)    |

end 

%% Informazioni legate a porte logiche
for h=1:length(ff)
    g=ff(h);
    pc=get_param(g,'PortConnectivity');
    % pc a questo punto  una struttura gia creata quindi posso scrivere:
    blocco=pc.DstBlock;  % identificativo del Blocco di destinazione 
    porta=pc.DstPort;    % identificativo della porta logica di destinazione
   
    % handle del blocco a cui  connesso (Vale solo per il Basic Event) 
    BC{h,1}=blocco; 
    % handle della porta a cui  connesso
    gate(h,1)=porta; % mi dice a che porta sono collegato
end 


end    % End Function 

%{
1) Con find_system trovo tutti i blocchi che hanno come MaskType Basic_Event
del modello specificato (es. FTA);
2) prendo la handle di ognuno di questi blocchi e trasformo il vettore cosi
creato da arrey cella a un arrey di variabili numeriche;
3) Con un ciclo for avendo la handle numerica dei blocchi Basic Event,
ciclo tutte le handle prendendo le propriet dei Basic Event e inserendole
in un vettore di celle, Ev{}; 
4) Avendo sempre le handle dei basi event prendo per ognuno di essi la
propriet "PortConnectivity" che  una struttura che contiene diverse
handle tra cui DstBlock (handle del blocco di destinazione) e DstPort
(handle della porta di destinazione) e inserisco le info in due vettori,
BC e gate;



%}
