

%% Funzione di pulizia del modello COMPLETA


function clean_model_FULL(model_name)


%% Trovo i Basic Event
f_basic=find_system(model_name,'MaskType','Basic_Event'); 
f_basic=cell2mat(get_param(f_basic,'Handle')); 

%% Trovo gli intermidiate event 
f=find_system(model_name,'MaskType','Intermediate_Event'); % handle intermidiate event
f=cell2mat(get_param(f,'Handle')); % da cell array a handle 

%% Trovo il TOP
f_top=find_system(model_name,'MaskType','Top_Event'); % handle Top Event
f_top=cell2mat(get_param(f_top,'Handle')); % da cell array a handle 

%% Trovo le porte logiche
ff=find_system(model_name,'BlockType','Logic'); % Handle dei Blocchi logici
ff=cell2mat(get_param(ff,'Handle'));

%% Trovo pannello di controllo
f_control_panel=find_system(model_name,'MaskType','Control_Panel_FTA'); % Handle del pannello di controllo
f_control_panel=cell2mat(get_param(f_control_panel,'Handle'));

%% Trovo i CCF
f_ccf=find_system(model_name,'MaskType','CCF_Event'); 
f_ccf=cell2mat(get_param(f_ccf,'Handle')); 

%% Trovo i blocchi description
f_desc=find_system(model_name,'MaskType','Description_Ev'); 
f_desc=cell2mat(get_param(f_desc,'Handle')); 


%% Cancello la propriet Dialog Box Basic e Description
for aa=1:length(f_basic) 
    l=f_basic(aa);
    set_param(l,'block_type','[]');  
    set_param(l,'mod','[]');  
    set_param(l,'comp_type','[]'); 
    set_param(l,'tag_ev','[]');
    
    set_param(l,'lam_mttf','[]');
    set_param(l,'mu_mttr','[]'); 
    set_param(l,'dt','[]'); 
    set_param(l,'test','[]'); 
    set_param(l,'UnAv','[]'); 
    set_param(l,'UnRe','[]');
    set_param(l,'f_density','[]');
    set_param(l,'SC','[]');
    set_param(l,'SC_show','[]');
    
    set_param(l,'Description',''); 
end



%% Cancello la propriet Dialog Box Intermediate e Description
for aa=1:length(f) 
    l=f(aa);
    set_param(l,'Description',''); 
    set_param(l,'check_if_full','[]');  
    set_param(l,'sym','[]');
    set_param(l,'dt','[]'); 
    
    set_param(l,'tag_int','[]');
    set_param(l,'lam_int','[]');
    set_param(l,'Qt','[]'); 
    set_param(l,'Ft','[]'); 
    set_param(l,'wt','[]'); 
    set_param(l,'dt','[]'); 
    
    set_param(l,'SC','[]');
    set_param(l,'SC_show','[]');
    
end
%% Cancello la Description delle porte logiche
for a=1:length(ff)
    ll=ff(a);
    set_param(ll,'Description',''); 
end

%% Cancello la propriet Dialog Box Top Event e Description
for aa=1:length(f_top) 
    l2=f_top(aa);
    
     set_param(l2,'Description','');
     set_param(l,'dt','[]'); 
     
    % Top ful
    set_param(l2,'top_eq_full','[]');   
    set_param(l2,'tag_top','[]');
    set_param(l2,'lam_top','[]');
    set_param(l2,'Qt','[]'); 
    set_param(l2,'Ft','[]'); 
    set_param(l2,'wt','[]'); 
    % Top Mcs
    set_param(l2,'top_MCs','[]');
    set_param(l2,'lam_top_MCs','[]');
    set_param(l2,'Qt_MCs','[]'); 
    set_param(l2,'Ft_MCs','[]'); 
    set_param(l2,'wt_MCs','[]');     
    
    set_param(l2,'SC','[]');  
    set_param(l2,'SC_show','[]');  
    
    
end

%% Cancello "description" e propriet dal blocco pannello di controllo
set_param(f_control_panel,'Description',''); 
set_param(f_control_panel,'model_sim','[]'); 
set_param(f_control_panel,'SC','[]'); 
set_param(f_control_panel,'SC_show','[]');
set_param(f_control_panel,'dt','[]');

%% Cancello la propriet Dialog Box CCF e Description
for aa=1:length(f_ccf) 
    l=f_ccf(aa);
    set_param(l,'beta_f','[]');  
    set_param(l,'beta_type','[]');  
    set_param(l,'SC','[]'); 
    set_param(l,'SC_show','[]');   
    set_param(l,'pop_bf','[]');
    set_param(l,'ccf_tag_events','[]'); 
    
    set_param(l,'tag_ev','[]'); 
    set_param(l,'lam_ccf','[]'); 
    set_param(l,'Q_ccf','[]'); 
    set_param(l,'F_ccf','[]');
    set_param(l,'w_ccf','[]');

    
    set_param(l,'Description',''); 
end


%% Cancello description dal blocco Description
for a=1:length(f_desc)
    ll=f_desc(a);
    set_param(ll,'Description',''); 
    set_param(ll,'desc_ev','[]');
end



end