function cycle_Top(model)


%% Trovo il Top Event
% Trova i nomi Mask Type di tutti i blocchi che si chiamano "Top_Event" e li mette in un array di celle;
f=find_system(model,'MaskType','Top_Event'); % Handle dei basic events

% Da cell ad array cosi che le handle siano numeri
f=cell2mat(get_param(f,'Handle')); 


for h=1:length(f)
    
    g=f(h);% Handle dell'Intermidiate Event che viene ciclato

    pc=get_param(g,'PortConnectivity'); %  una struttura
       
    %% Prendo la handle del blocco sorgente ( sempre una) 
    Input_block_h=pc(1).SrcBlock;  % Handle Porta logica INPUT 
    
    desc_logic_sub_int=get_param(Input_block_h,'Description');
    desc_logic_sub_int=spezza_tranci(desc_logic_sub_int,char(10));
    
    % Numero di connessioni della porta logica
    ...(perch si suppone che abbia propagato tutti gli eventi)
    n_connection=length(desc_logic_sub_int);
    
    
    param_b={};
    param_b_c={};
    %% Parametrito Top Event MIX
    % cell array con i parametri del Basic Ev
    for j=1:length(desc_logic_sub_int)
    param_b(:,j)=spezza_tranci(desc_logic_sub_int{j},' '); 
     % creo un cell array in cui il primo elemento lo lascio sctringa e
     ...tutti gli altri li converto in double
    param_b_c(:,j)=[param_b(1,j) cellfun(@str2num,param_b(2:end,j),'un',0).'];
    end
   
    
    %% OPERAZIONI MATEMATICHE
    % Elimino riga contenente le Tag degli Eventi
    param_b_cc=param_b_c;
    param_b_cc(1,:) = [];
    % converto in matrice di array
    param_b_cc=cell2mat(param_b_cc);
    %% matrice di double contenente i lambda, Q, F, w del Cut Set Finale
    size_param_b_c=size(param_b_cc);
    size_param_b_c=size_param_b_c(2); % prendo il numero di colonne dell'array che contiene i barametri Basic event
    
    for jj=1:size_param_b_c
%     array_lambda_basic(jj)=param_b_cc(1,jj);   % array righe  [LAMBDA]
    array_Q_basic(jj)=param_b_cc(2,jj);        % array righe    [Q]
%     array_F_basic(jj)=param_b_cc(3,jj);        % array righe    [F]
    array_w_basic(jj)=param_b_cc(4,jj);        % array righe    [w]
    end
    
    %% Riconoscimento porta logica e lambda, Q, F dell' Intermidiate Event
    check_logic=string(get_param(Input_block_h,'MaskType')); % me lo prende con char(10)    

    
    if check_logic=='AND'
        
%     lambda_int=prod(array_lambda_basic);
    Q_int=prod(array_Q_basic);
%     F_int=prod(array_F_basic);
    w_int=w_cut(n_connection,array_Q_basic,array_w_basic);
    
    elseif check_logic=='OR'
        
%     lambda_int=sum(array_lambda_basic);
    Q_int=sum(array_Q_basic);
%     F_int=sum(array_F_basic); 
    w_int=sum(array_w_basic);       
    end 
    
  
% Time mission
dt=string(get_param(gcb,'dt'));
dt=str2double(dt);
  
  %% CFI 
  CFI=w_int/(1-Q_int);
  
  %% F_system  
  F_int=1-exp(-CFI*dt);
  
   
   %% Setto lambda, Q, F, W come propriet dialog box
  set_param(g,'lam_top',string(CFI));
  set_param(g,'Qt',string(Q_int)); 
  set_param(g,'Ft',string(F_int)); 
  set_param(g,'wt',string(w_int)); 
  
  
  
%% Tag Top event    
tag=string(get_param(g,'MaskType'));  % propago la tag del Top con il nome della maschera  
if tag=="[]"
    tag=string(get_param(gcb,'MaskType')); % o MaskType o Name
    set_param(gcb,'tag_top',tag); 
end  

        
end


end