
function cycle_int(model)



%% Trovo gli intermediate event 
% Trova i nomi Mask Type di tutti i blocchi che si chiamano "Intermidiate_Event" e li mette in un array di celle;
f=find_system(model,'MaskType','Intermediate_Event'); % Handle degli Intermidiate events

% Da cell ad array cosi che le handle siano numeri
f=cell2mat(get_param(f,'Handle')); %Prende le handle di tutti gli Intermidiate Event


%% Variabile di conteggio Intermediate Event 

count_int=0;
% Numero inermidiate event da completare
num_int=length(f);
% Variabile per far terminare il ciclo while
end_while=0;
% Contatore dei cicli while impiegati per completare tutti gli intermidiate
ii=0;

while end_while<num_int
    ii=ii+1;
%% Ciclo le handle degli intermidiate
for h=1:length(f)
    
    g=f(h);% Handle dell'Intermidiate Event che viene ciclato

    pc=get_param(g,'PortConnectivity'); %  una struttura
    
    
    %% Prendo la handle del blocco sorgente (  sempre una) 
    Input_block_h=pc(1).SrcBlock;  % Handle Porta logica INPUT 
    %% Prendo la pripriet "PortConnectivity" del blocco
    pc_logic=get_param(Input_block_h,'PortConnectivity');
    gate=[];    
    %% CICLO SULLA PORTA LOGICA SORGENTE e vedo quanti input ha la porta logica
     gate=[]; 
for hh=1:(length(pc_logic)-1)
    % -1 perch voglio i valori che si riferiscono alle porte di ingresso,...
    ...mentre l'ultima righa di pc_logic  il blocco di destinazione(l'intermidiate quindi)
    

    % handle del blocco sorgente
    handle_source_block=pc_logic(hh).SrcPort;   
    % handle della porta a cui  connesso, In base a questo vettore vedo
    ...quanti basic event sono collegati alla porta logica
    gate(hh,1)=handle_source_block;      
end

%% Numero di Eventi connessi alla porta logica 
n_connection=length(gate);
%% Output 1 della funzione ( vettore che contiene handle dell'intermidiate event e il numero di eventi connessi)
% vettore che contiene l'Handle dell'intermidiate event e il numero di
% eventi connessi a quell'intermidiate 

%% Prendo il campo description dalla porta logica sorgente all'intermidiate
desc_logic_sub_int=get_param(Input_block_h,'Description');
desc_logic_sub_int=spezza_tranci(desc_logic_sub_int,char(10));


%% INTERMIDIATE EVENT COMPLETO 
% Inserisci "full" in "check_if_full" 
% Se il numero di righe del campo "description" della porta logica  = al
...numero di input alla porta logica vuol dire che sono stati propagati
...tutti gli eventi
get_full=string(get_param(g,'check_if_full'));

if (length(desc_logic_sub_int)==n_connection) &  ~strcmp(get_full,'full')
    
    % Flag "full" che mi segna come "complete" le info che passer
    ...all'intermidiate event
    set_param(g,'check_if_full','full');
    % Aumento contatore intermidiate
    count_int=count_int+1; 
    % inizializzo cell array che conterr i valori presi da Description
    ...della porta logica
    param_b={};
    param_b_c={};
    param_b_tag={};
    %% Parametri Basic event to Intermidiate MIX
    % cell array con i parametri del Basic Ev
    for j=1:length(desc_logic_sub_int)
    param_b(:,j)=spezza_tranci(desc_logic_sub_int{j},' '); 
     % creo un cell array in cui il primo elemento lo lascio sctringa e
     ...tutti gli altri li converto in double
    param_b_c(:,j)=[param_b(1,j) cellfun(@str2num,param_b(2:end,j),'un',0).'];
    end
    
    %% OPERAZIONI MATEMATICHE
    % Elimino riga contenente le Tag degli eventi basici
    param_b_cc=param_b_c;
    % Prendo le tag dei Basic event per sostituzione dell'eq. simbolica del
    ...Cut Set
    param_b_tag(:,1)=param_b_cc(1,:);
    param_b_cc(1,:) = [];
    % converto in matrice di array
    param_b_cc=cell2mat(param_b_cc);
    %% matrice di double contenente i lambda, Q, F, w dei Basic Event
    size_param_b_c=size(param_b_cc);
    size_param_b_c=size_param_b_c(2); % prendo il numero di colonne dell'array che contiene i barametri Basic event
    
    %% Parametri da sostituire nell'equazione del Cut Set
    % inizializzo array che conterranno le propriet dell'evento
%     array_lambda_basic=[];
    array_Q_basic=[];
   % array_F_basic=[];
    array_w_basic=[];
    
    for jj=1:size_param_b_c
%     array_lambda_basic(jj)=param_b_cc(1,jj);   % array righe  [LAMBDA]
    array_Q_basic(jj)=param_b_cc(2,jj);        % array righe    [Q]
 %   array_F_basic(jj)=param_b_cc(3,jj);        % array righe    [F]
    array_w_basic(jj)=param_b_cc(4,jj);        % array righe    [w]
    end
   
    
    
    %% Calcolo di W_cut 
    % Riconoscimento porta logica e lambda, Q, F dell' Intermidiate Event
    check_logic=string(get_param(Input_block_h,'MaskType'));    

    if check_logic=='AND'
     
    % W del Cut Set 
    % Dipendente dal Cut Set
    w_int=w_cut(n_connection,array_Q_basic,array_w_basic);
    
    elseif check_logic=='OR'
        
    % W del Cut Set
    % Indipendente dal Cut Set    
    w_int=sum(array_w_basic);
    end 
 
   
  %% Setto lambda, Q, F, W_cut come propriet dialog box
  tag=get_param(g,'tag_int');
%   lambda_int=get_param(g,'lam_int');
  Q_int=get_param(g,'Qt');
  Q_int=str2double(Q_int);
  

% Time mission
dt=string(get_param(gcb,'dt'));
dt=str2double(dt);
  
  %% CFI Intermidiate secondo Faulttree+
  CFI=w_int/(1-Q_int);
  
  %% F_system Intermidiate secondo Faulttree+
   a=string(get_param(g,'SC'));
   if a~="F" % Success criteria Q o W
   F_int=get_param(g,'Ft');
   else % UnReliability quindi componenti non riparabili
  F_int=1-exp(-CFI*dt);
   end
  
  % Avendo gia settato Q_int nella funzione PropNum_lam_Q_F_int devo
  % settare il CFI, F, w 
  set_param(g,'lam_int',string(CFI)); 
  set_param(g,'Ft',string(F_int)); 
  set_param(g,'wt',string(w_int)); 
  
  %% Description Intermidiate Event
  description_int={tag string(CFI) string(Q_int) string(F_int) string(w_int)};
  description_int=join(string(description_int),' ');
  set_param(g,'Description',char(description_int));
   
      
   %% Propago alla porta logica superiore (OutPut del Basic Event) 

   %% Handle porta logica di OutPut
   % Se non ho un Output prende l'handle del blocco stesso
   Output_block_h=pc(2).DstBlock;  % Handle Porta logica INPUT 
   descr=get_param(Output_block_h,'Description');  % vede la porta logica a  cui sono connesso 

    if isempty(descr);
            
        descr=char(description_int); 
    else
        % se non  vuoto concatena 
        descr=[descr char(10) char(description_int)];   
    end
    descr=join(descr,' ');
    set_param(Output_block_h,'Description',char(descr));
  
end   % "end" di "" if length(desc_logic_sub_int)==n_connection ""

   end_while=count_int;
  
end  % "end" del ciclo degli Intermidiate

end % "end" while (count_int)

end


